##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

import sys, os
package_home = os.path.dirname(__file__)
if not package_home in sys.path:
    sys.path.insert(0, package_home)

from Products.CMFDefault import Portal
import CollectorNG, CollectorNGIssue
import Products.CMFCore

from Products.CMFCore import utils, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory
import CollectorNGPermissions

this_module = sys.modules[ __name__ ]

factory_type_information = (
    (CollectorNG.factory_type_information
   + CollectorNGIssue.factory_type_information
   + CollectorNG.catalog_factory_type_information
     )
    )

contentClasses = (CollectorNG.CollectorNG, CollectorNGIssue.CollectorNGIssue,
                  CollectorNG.CollectorNGCatalog)
contentConstructors = (CollectorNG.addCollectorNG,
                       CollectorNGIssue.addCollectorNGIssue)
z_bases = utils.initializeBasesPhase1(contentClasses, this_module)
# This is used by a script (external method) that can be run
# to set up CollectorNG in an existing CMF Site instance.
collector_globals = globals()

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/collectorng', globals())
registerDirectory('skins/collectorng1', globals())

def initialize(context):
    utils.initializeBasesPhase2(z_bases, context)
    context.registerHelp(directory='help')
    context.registerHelpTitle('CMF CollectorNG Help')

    context.registerClass(CollectorNG.CollectorNG,
                          constructors = (CollectorNG.addCollectorNGForm,CollectorNG.addCollectorNG),
                          permission = CMFCorePermissions.AddPortalContent)

    context.registerClass(CollectorNGIssue.CollectorNGIssue,
                          constructors = (CollectorNGIssue.addCollectorNGIssue,),
                          permission = CollectorNGPermissions.AddCollectorIssue)


from AccessControl import ClassSecurityInfo, ModuleSecurityInfo

def allow_class(Class): 
    """Allow a class and all of its methods to be used from a 
    restricted Script. The argument Class must be a class.""" 
    Class._security = sec = ClassSecurityInfo() 
    sec.declareObjectPublic() 
    sec.setDefaultAccess(1) 
    sec.apply(Class) 
    from Globals import InitializeClass 
    InitializeClass(Class)

from PloneBatch import Batch
allow_class(Batch)
ModuleSecurityInfo('Products.CMFCollectorNG').declarePublic("Batch")

from textwrap import wrap
ModuleSecurityInfo('Products.CMFCollectorNG').declarePublic("wrap")

import gettext
ModuleSecurityInfo('Products.CMFCollectorNG').declarePublic("gettext")

import zLOG
ModuleSecurityInfo('Products.CMFCollectorNG').declarePublic("zLOG")


from Products.PythonScripts.Utility import allow_module
allow_module('zLOG')

