from Products.CMFCollectorNG.CollectorNGProperties import CollectorNGProperty

# property configuration for CollectorNG instances

all_collector_properties = (

    CollectorNGProperty(id='title',     
            description='Title', 
            type='text',
            used=1,
            mandatory=1,
            ),                              

    CollectorNGProperty('email', 
            description='Tracker email', 
            type='text',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('hostname', 
            description='Canonical hostname', 
            type='text',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('recatalog', 
            description='Recatalog', 
            type='select',
            values="0,No|1,Internal only|2,Internal and site wide (slow)",
            default=0,
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('abbrev', 
            description='Abbreviation',  
            type='text',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('managers', 
            description='Managers', 
            type='select-multiple',
            default=[],
            used=1,
            mandatory=1,
            help="Trackeradministratoren konfigurieren den Tracker und "
                 "erhalten Benachrichtigungen ber Requests. Sie knnen "
                 "Tickets akzeptieren, aber mssen auf der "
                 "Entwicklerliste sein, um Tickets zugewiesen zu bekommen. " 
                 "(Sie knnen sich auch nicht selber von der "
                 "Trackeradministratorenliste entfernen",
            ),

    CollectorNGProperty('supporters', 
            description='Supporters', 
            type='select-multiple',
            default=[],
            used=1,
            mandatory=1,
            help="Entwickler knnen Tickets aufgeben oder zugewiesen bekommen. "
                 "Ticket Benachrichtigungen werden entweder an alle Entwickler "
                 "oder nur an die zugewiesenen Entwickler verschickt."
            ),

    CollectorNGProperty('reporters', 
            description='Reporters', 
            type='select-multiple',
            default=[],
            used=1,
            mandatory=1,
            help="Reporter knnen Tickets aufgeben und nachtrglich "
                 "Referenzen/Uploads anlegen, jedoch keine weiteren Followups."
            ),

    CollectorNGProperty('description', 
            description= 'Description', 
            type='textarea',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('limit_followups', 
            description='Limit followups', 
            type='select', 
            values='0,No|1,Yes',
            default='0',
            used=1,
            mandatory=1
            ),

    CollectorNGProperty('participation', 
            description='Participation', 
            type='select', 
            values='staff,Only collector staff and issue requester participate in an issue|authenticated,Any non-anonymous visitors can participate|anyone,Anyone, including anonymous visitors, can chime in',
            default='staff',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('restricted_visibilty', 
            description='Restricted visibility', 
            type='select', 
            values='0,no restrictions|1,only visible to registered users',
            default=0,
            used=1,
            mandatory=1,
            help="""Einschrnkung der Sichtbarkeit fr Tickets nur auf eingetragene Teilnehmer"""
            ),

    CollectorNGProperty('dispatching', 
            description='Dispatcher mode', 
            type='select', 
            values='all,All managers, developers and reporters|assigned,All managers, assigned developers and reporters|none,No notifications',
            default='assigned',
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('email_submissions', 
            description='Email submissions', 
            type='select', 
            values='0,disabled|1,enabled',
            default=0,
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('newissue_token', 
            description='Email token for new issues', 
            type='text', 
            default="",
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('batch_size', 
            description='Batch size', 
            type='select', 
            values="1|5|10|20|50|100",
            default=10,
            used=1,
            mandatory=1,
            ),

    CollectorNGProperty('ticket_offset',
            description='Number of days until deadline for new issues',
            type='int',
            values="0|7|14|21|28",
            default=14,
            used=1,
            mandatory=0,
            ),

    CollectorNGProperty('datefmt_short',
            description='Short date',
            type='select',
            values="%d.%m.%Y|%d.%m.%y|%Y%m%d|%m.%d.%Y",
            default='%d.%m.%Y',
            used=1,
            mandatory=0,
            ),

    CollectorNGProperty('datefmt_long',
            description='Long date',
            type='select',
            values="%d.%m.%Y %H:%M:%S|%d.%m.%y %H:%M:%S|%Y%m%d %H:%M:%S|%m.%d.%Y %H:%M:%S",
            default='%d.%m.%Y %H:%M:%S',
            used=1,
            mandatory=0,
            ),
)

