from Products.CMFCollectorNG.CollectorNGProperties import CollectorNGProperty

# property configuration for issues

all_issue_properties = (

    CollectorNGProperty(id='title',     
            description='Title', 
            type='text',
            used=1,
            mandatory=1,
            category='meta',
            ),                              

    CollectorNGProperty('topic', 
            description='Topic', 
            type='select',
            values='Category1|Category2' , 
            used=1,
            mandatory=1,
            notify_on_change='update_subtopic',
            category='meta',
            ),                              

    CollectorNGProperty('subtopic', 
            description='Subtopic', 
            type='select',
            default='',
            values='(Category1:K1|K2|K3)|(Category2:K4|K5|K6)' , 
            used=1,
            mandatory=1,
            category='meta',
            ),                              

    CollectorNGProperty('security_related', 
            description='Security related', 
            type='select',
            values='0,no|1,yes', 
            default=0,
            used=1,
            mandatory=1,
            category='meta',
            ),                              

    CollectorNGProperty('importance', 
            description='Importance', 
            type='select',
            values='0,low|1,medium|2,high|3,critical', 
            default='1',
            used=1,
            mandatory=1,
            category='meta',
            ),

    CollectorNGProperty('classification', 
            description='Classification',  
            type='select',
            values='Bug|Bug+Solution|Feature|Feature+Solution|Documentation', 
            default='Bug',
            used=1,
            mandatory=1,
            category='meta',
            ),

    CollectorNGProperty('version_info', 
            description='Version info', 
            type='text',
            default='',
            used=1,
            category='meta',
            ),

    CollectorNGProperty('description', 
            description= 'Description', 
            type='textarea',
            used=1,
            mandatory=1,
            category='meta',
            ),

    CollectorNGProperty('submitter_company', 
            description='Company', 
            type='text', 
            default='',
            used=1,
            mandatory=0,
            category='submitter',
            ),

    CollectorNGProperty('submitter_position', 
            description='Position', 
            type='text', 
            default='',
            used=1,
            mandatory=0,
            category='submitter',
            ),


    CollectorNGProperty('submitter_name', 
            description='Name', 
            type='text', 
            default='',
            used=1,
            mandatory=1,
            category='submitter',
            ),

    CollectorNGProperty('submitter_address', 
            description='Address', 
            type='text', 
            default='',
            used=1,
            category='submitter',
            ),

    CollectorNGProperty('submitter_city', 
            description='City', 
            type='text', 
            default='',
            used=1,
            category='submitter',
            ),

    CollectorNGProperty('submitter_phone', 
            description='Phone', 
            type='text', 
            default='',
            used=1,
            category='submitter',
            ),

    CollectorNGProperty('submitter_fax', 
            description='Fax', 
            type='text', 
            default='',
            used=1,
            category='submitter',
            ),

    CollectorNGProperty('submitter_email', 
            description='Email', 
            type='text', 
            default='',
            used=1,
            mandatory=1,
            category='submitter',
            ),

    CollectorNGProperty('hours_required',
            description='Estimated number of hours', 
            type='float',
            default=0,
            used=1,
            category='effort',
            ),

    CollectorNGProperty('hours_needed',
            description='Hours used', 
            type='float',
            default=0,
            used=1,
            category='effort',
            ),


    CollectorNGProperty('deadline',
            description='Deadline', 
            type='date',
            default='31.12.2036',
            used=1,
            help='Format DD.MM.YYYY',
            category='effort',
            ),

    CollectorNGProperty('operating_system',
            description='Operating system', 
            type='select-multiple',
            values='All platforms|Windows 95|Windows 98|Windows ME|Windows 2000|Windows XP|Linux|Solaris|other',
            default='',
            used=1,
            mandatory=1,
            category='effort',
            ),

    CollectorNGProperty('status',
            description='Status', 
            type='text',
            default='',
            used=1,
            mandatory=1,
            category='effort',
            ),

    CollectorNGProperty('solution',
            description='Solution', 
            type='textarea',
            default='',
            used=1,
            mandatory=0,
            category='meta',
            ),

    CollectorNGProperty('assignees',
            description='Assignees', 
            type='select-multiple',
            default='',
            used=1,
            mandatory=1,
            category='effort',
            ),

    CollectorNGProperty('progress',
            description='Progress', 
            type='select',
            values="0,0%|25,25%|50,50%|75,75%|100,100%",
            default=0,
            used=1,
            mandatory=1,
            category='effort',
            ),
)
