## Script (Python) "collector_search.py"
##title=Collector Search

from AccessControl import getSecurityManager
import zLOG

#zLOG.LOG('search',zLOG.INFO, context.REQUEST.text())

tracker_id = context.getId()

searchable_fields = ("SearchableText", "Creator", "classification", "topic",
                     "assigned_to", "resolution", "version_info", "importance",
                     "deadline", "progress", "security_related", "status")


def query_sort(a, b):
    """ helper method to sort the result list """

    # get values
    va = getattr(a, sort_on)
    vb = getattr(b, sort_on)

    # try to convert the values to ints
    try:
        va = int(va)
        vb = int(vb)
    except: pass

    if sort_direction=="desc": return -1 * cmp(va, vb)
    else:                      return cmp(va, vb)


reqget = context.REQUEST.get
session = context.REQUEST.SESSION
user = getSecurityManager().getUser()
username = user.getUserName()

# minor hack to support "jump to ticket" functionality
if reqget('ticketnumber'): return 1

# Build the query
query = {}
query['Type'] = "CollectorNG Issue"

sort_on = reqget('sort_on','getId')
sort_direction = reqget('sort_direction','desc')
searching = reqget('searching', None)

# This is a fast-filter to get tickets which be submitted
# or those where we are assigned to.

myfilter = reqget('filter',None)

if myfilter:
    query['status'] =  ['Pending', 'Accepted']

    if myfilter=='myassigned':
        query['assigned_to'] =  (username,) 

    if myfilter=='mysubmitted':
        query['Creator'] = (username,) 

else:

    # No fast filter -> build up query

    for field in searchable_fields:
    
        val = reqget(field, None)
        if val:
            query[field] = val

# use stored parameters from session object if

if not searching:
    # no new search -> use stored query from session object
#    zLOG.LOG('search',zLOG.INFO, 'using stored search')

    try:
        query = session['lastsearch'][tracker_id] # take query from session
    
        for k,v in session['lastsearch'][tracker_id].items(): # fake form parameters
            context.REQUEST.form[k] = v

    except:
        context.REQUEST.form['status'] = query['status'] = ['Pending', 'Accepted']


# Include confidential alternatives to selected states.
for st in query.get('status', []):
    if st in ('Pending', 'Accepted'):
        query['status'].append("%s_confidential" % st)

# store search in session object
if searching:
    if not session.has_key('lastsearch'):
        session['lastsearch'] = {}
    session['lastsearch'][tracker_id] = query


#zLOG.LOG('search',zLOG.INFO, query)

# do the query
catalog = context.get_internal_catalog()
brains = list(catalog(REQUEST=query)) # we need list() to be able to sort() the lazy map

# sort results
if sort_on: brains.sort(query_sort)                                                 

# filter out confidential tickets
brains = [ brain for brain in brains 
                 if brain.getObject().isVisibleFor(user) ]

# filter unassigned tickets
if myfilter=="unassigned":
    brains = [ brain for brain in brains 
                     if len(brain.getObject().assigned_to()) == 0 ] 

return brains
