## Script (Python) "collector_stats.py"

# Retrieve some statistics about tickets

from AccessControl import getSecurityManager
username = getSecurityManager().getUser().getUserName()


# determine total number of tickets
total_tickets = len(context.objectIds('CMF CollectorNG Issue'))


# determine number of open tickets
query = {}
query['Type'] = "CollectorNG Issue"
query['status'] = ['Pending', 'Accepted', 'Pending_confidential', 'Accepted_confidential']
got = list(context.get_internal_catalog()(REQUEST=query))
open_tickets = len(got)


# determine number of my created tickets
query = {}
query['Type'] = "CollectorNG Issue"
query['status'] = ['Pending', 'Accepted', 'Pending_confidential', 'Accepted_confidential']
query['Creator'] = username
got = list(context.get_internal_catalog()(REQUEST=query))
my_created_tickets = len(got)


# determine number of tickets I am assigned to
query = {}
query['Type'] = "CollectorNG Issue"
query['status'] = ['Pending', 'Accepted', 'Pending_confidential', 'Accepted_confidential']
query['assigned_to'] = username
got = list(context.get_internal_catalog()(REQUEST=query))
my_assigned_tickets = len(got)

return (total_tickets, open_tickets, my_created_tickets, my_assigned_tickets)
