""" Transcript formatters """

from cStringIO import StringIO

from zLOG import LOG,INFO

def format_transcript(issue):

    def f(text):
        return '\n'.join( [ '  %s' % s for s in text.split('\n') ] )

    IO = StringIO()

    print >>IO,'%s #%s - %s' % (issue.trans("Issue"), issue.getId(), issue.title )
    print >>IO,'Topic: %s/%s' % (issue.topic, issue.subtopic) 
    print >>IO,'Status %s,   %s: %s/%s' % (issue.trans(issue.status()), issue.trans("Classification"), 
                issue.classification, issue.importance)

    if issue.issuePropertyManager.getPropertyById('deadline').getUsed():
        print >>IO,'Deadline: %s' % (issue.deadline.strftime(issue.datefmt_short))
    print >>IO,'Ticket URL: http://%s/%s' % (issue.hostname, issue.absolute_url(relative=1))
    print >>IO,'-'*75 + '\n'

    for entry in issue.getTranscript():

        print >>IO,'#%-3d -------------- %s %s -----------' % \
         (entry.getNumber(), entry.getTimestamp().strftime('%d.%m.%Y %H:%M:%Sh'), entry.getUser())

        for k, v in (('Comments', entry.getComments()), ('Changes', entry.getChanges()),
                     ('Uploads', entry.getUploads()), ('References', entry.getReferences())):

            for item in v:
                print >>IO, "%-12s %s" % ("%s:" % issue.trans(k), f(str(item)))
        
        print >>IO

    return IO.getvalue()

def format_transcript_as_xml(issue):
    """ format the transcript as XML document """

    IO = StringIO()
    T = issue.getTranscript()
    print >>IO,'<transcript>'
    for entry in T: print >>IO,(entry.asXML() + '\n')
    print >>IO,'</transcript>'

    return IO.getvalue()
